 -- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local timers = {}

local timings_tmp = {}
local calls_tmp = {}
M.data = {}
M.frames = 0

local sec = 0
local frames = 0

local function nop()
end

local function start(name)
    if timers[name] == nil then
        timers[name] = HighPerfTimer()
    else
        timers[name]:reset()
    end
end

local function stop(name)
    if not timings_tmp[name] then
        timings_tmp[name] = 0
        calls_tmp[name] = 0
    end
    timings_tmp[name] = timings_tmp[name] + timers[name]:stop()
    calls_tmp[name] = calls_tmp[name] + 1
end

local function update(dt)
    sec = sec + dt
    frames = frames + 1
    if sec > 1 then
        sec = sec - 1
        M.frames = frames
        frames = 0
        M.data = {}
        for k,v in pairs(timings_tmp) do
            if calls_tmp[k] > 0 then
                M.data[k] = { timings_tmp[k], calls_tmp[k] }
                timings_tmp[k] = 0
                calls_tmp[k] = 0
            end
        end
    end
end

local function enable(val)
    if val then
        M.start = start
        M.stop = stop
        M.update = update
    else
        M.start = nop
        M.stop = nop
        M.update = nop
        M.data = {}
        M.frames = 0
    end
end

-- public interface
M.start = start
M.stop = stop
M.update = update
M.enable = enable

return M